/*
Scrivere un programma per la gestione delle automobili e dei noleggi.
Le automobili sono caratterizzate dalle seguenti informazioni: targa, anno di immatricolazione, chilometri percorsi, classe (0..3). 
I noleggi sono caratterizzati dalle seguenti informazioni: targa, codice fiscale del richiedente, giorno noleggio,  tipo di tariffa (0=ordinaria, 1=weekend, 2=WEB).
Le automobili sono inserite in un vettore di 4 liste, una per ogni classe. 
I noleggi sono  inseriti in una tabella allocata dinamicamente avente 3 righe, una  per ogni tipo di tariffa. 

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento nel vettore di liste di una nuova automobile; 
2.	Eliminazione di unautomobile dopo averla visualizzata
3.	Inserimento di un nuovo noleggio;
4.	Visualizzazione dei noleggi di un certo tipo;
5.	Lettura da file dei noleggi precedentemente salvati e inserimento in tabella;
6.	Salvataggio su file della tabella dei noleggi.

Liberare la memoria allocata dinamicamente.

*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct {
        char targa[10];
        int anno, chilometri, classe;
        } automobile;

typedef struct {
        char targa[10], giorno[12], codice[17];
        int tipo;
        } noleggio;
        
struct atomo {
       automobile dato;
       struct atomo *next;
       };
       
void leggi_auto(automobile *p);
void in_lista(struct atomo *VL[4]);
void elimina(struct atomo *VL[4]);
void leggi_noleggio(noleggio *n);
void inserisci_noleggio(noleggio *TB[3], int *N);
void visualizza(noleggio *TB[3], int *N);
void carica(noleggio *TB[3], int *N);
void salva(noleggio *TB[3], int *N);

main()
{
      int i, op, N[3];
      struct atomo *VL[4], *a;
      noleggio *TB[3];
      
      
      for(i=0;i<3;i++)
        {  TB[i]=NULL;
           N[i]=0;
           }
      
      for(i=0;i<4;i++)
      {    VL[i]=NULL;
      }
      
      do {
          printf("\n\nScegli fra:\n");
          printf(" 1) Inserisci automobile\n 2) Elimina automobile\n 3) Inserisci noleggio\n");
          printf(" 4) Visualizza noleggio\n 5) Leggi da file\n 6) Salva\n0) Fine\n\n");
          scanf("%d",&op);
          switch(op)
          { case 1: in_lista(VL);
                    break;
            case 2: elimina(VL);
                    break;
            case 3: inserisci_noleggio(TB,N);
                   break;
            case 4: visualizza(TB,N);
                    break;
            case 5: carica(TB,N);
                    break;
            case 6: salva(TB,N);
                    break;
            default: ;
            }} while(op);
            
            
            for(i=0;i<4;i++)
               while(VL[i])
                  { a=VL[i];
                    VL[i]=a->next;
                 free(a);
                 }
               
            for(i=0;i<3;i++)
                  free(TB[i]);
                  
}
                 

void leggi_auto(automobile *p)
{
     printf("Targa: "); scanf("%s", p->targa);
     printf("Anno di immatricolazione: "); scanf("%d", &p->anno);
     printf("Chilometri percorsi: "); scanf("%d", &p->chilometri);
     printf("Classe di appartenenza (0..3): "); scanf("%d", &p->classe);
}
void in_lista(struct atomo *VL[4])
{
     struct atomo *a;
     automobile p;
     
     leggi_auto(&p);
     
     a=malloc(sizeof(struct atomo));
     
     if(a==NULL) return;
     
     a->dato=p;
     a->next=VL[p.classe];
     VL[p.classe]=a;
     }
void elimina(struct atomo *VL[4])
{
     struct atomo *l1, *l2;
     int p;
     char targa[10];
     
     printf("Classe automobile (0..3) ");
     scanf("%d",&p);
     
     if(VL[p]==NULL)
     { printf("Nessuna automobile in questa categoria");
        return;
        }
      printf("Targa automobile da eliminare: ");
     scanf("%s",targa);  
        
        if(strcmp(targa,VL[p]->dato.targa)==0)
        { l1=VL[p];
          VL[p]=l1->next;
           printf("Anno di immatricolazione: %d\n", l1->dato.anno);
           printf("Chilometri percorsi: %d\n\n", l1->dato.chilometri);
           free(l1);
           return;
           }
        
        l2=VL[p];
        l1=l2->next;
        while(l1)
         if(strcmp(VL[p]->dato.targa,targa)==0)
          { l2->next=l1->next;
            printf("Anno di immatricolazione: %d\n", l1->dato.anno);
           printf("Chilometri percorsi: %d\n\n", l1->dato.chilometri);
           free(l1);
           return;
           }
          else
          { l1=l1->next;
            l2=l2->next;
            }
         printf("Elemento non trovato\n");
           
     }
void leggi_noleggio(noleggio *n)
{
        printf("Targa: "); scanf("%s",n->targa);
        printf("Giorno : "); scanf("%s", n->giorno);
        printf("Codice fiscale cliente: "); scanf("%s", n->codice);
        printf("Tipo di tariffa (0=ordinaria, 1=weekend, 2= WEB"); scanf("%d", &n->tipo);

     }
void inserisci_noleggio(noleggio *TB[3], int *N)
{
     noleggio n, *a;
     
     leggi_noleggio(&n);
     a=realloc(TB[n.tipo],sizeof(noleggio)*(N[n.tipo]+1));
     if(a==NULL) return;
     
     TB[n.tipo]=a;
     TB[n.tipo][N[n.tipo]]=n;
     N[n.tipo]++;
     }
void visualizza(noleggio *TB[3], int *N)
{
     int p, i;
     
     printf("Tipo di noleggio da visualizzare: ");
     scanf("%d",&p);
     for(i=0;i<N[p];i++)
     {   printf("Targa: %s\n", TB[p][i].targa);
         printf("Codice fiscale: %s\n", TB[p][i].codice);
         printf("Giorno inizio noleggio: %s\n\n", TB[p][i].giorno);
         }
}
void carica(noleggio *TB[3], int *N)
{
     FILE *pf;
     noleggio n, *R;
     int tipo;
     
     pf=fopen("noleggio.dat","r");
     if(pf)
     { while(fread(&n,sizeof(noleggio),1,pf)>0)
     { tipo=n.tipo;
     
       R=realloc(TB[tipo],sizeof(noleggio)*(N[tipo]+1));
       if(R==NULL) return;
       
       TB[tipo]=R;
       TB[tipo][N[tipo]]=n;
       N[tipo]++;
       }
       fclose(pf);
       }
       
     else
     printf("Errore in lettura\n impossibile caricare, o non esiste un file precedentemente salvato\n");
     

     }
void salva(noleggio *TB[3], int *N)
{
     FILE *pf;
     int tipo;
     
     pf=fopen("noleggio.dat","w");
     
     if(pf)
     { for(tipo=0;tipo<3;tipo++)
       fwrite(TB[tipo],sizeof(noleggio),N[tipo],pf);
       fclose(pf);
       }
       
     else
     printf("Errore in scrittura\n salvataggio non eseguito\n");     
     }
